﻿using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Viewer.Win;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace CustomFontResolverSample
{
	public partial class Form1 : Form
	{
		PageReport _pageReport = new PageReport();
		FileInfo _info;
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			_info = new FileInfo("PageReportSample.rdlx");
			_pageReport.Load(_info);
			_pageReport.FontResolver = DirectoryFontResolver.Instance;
			_viewer.LoadDocument(_pageReport.Document);

			DirectoryInfo outputDirectory = new DirectoryInfo(@"C:\MyPDF");
			outputDirectory.Create();
			GrapeCity.ActiveReports.Export.Pdf.Page.Settings pdfSetting = new GrapeCity.ActiveReports.Export.Pdf.Page.Settings();
			GrapeCity.ActiveReports.Export.Pdf.Page.PdfRenderingExtension pdfRenderingExtension = new
					GrapeCity.ActiveReports.Export.Pdf.Page.PdfRenderingExtension();
			GrapeCity.ActiveReports.Rendering.IO.FileStreamProvider outputProvider = new GrapeCity.ActiveReports.Rendering.IO.FileStreamProvider(outputDirectory,
					System.IO.Path.GetFileNameWithoutExtension(outputDirectory.Name));
			outputProvider.OverwriteOutputFile = true;
			_pageReport.Document.Render(pdfRenderingExtension, outputProvider, pdfSetting);
			Process.Start(@"C:\MyPDF");
		}
	}
	public sealed class DirectoryFontResolver : IFontResolver
	{
		static readonly GrapeCity.Documents.Text.FontCollection _fonts = new GrapeCity.Documents.Text.FontCollection();
		static DirectoryFontResolver()
		{
			_fonts.RegisterDirectory("Fonts");
			_fonts.DefaultFont = _fonts.FindFamilyName("Arial");
		}
		public static IFontResolver Instance = new DirectoryFontResolver();
		private DirectoryFontResolver() { }
		GrapeCity.Documents.Text.FontCollection GrapeCity.ActiveReports.IFontResolver.GetFonts(string familyName, bool isBold, bool isItalic)
		{
			var fonts = new GrapeCity.Documents.Text.FontCollection();
			var font = _fonts.FindFamilyName(familyName, isBold, isItalic);
			Debug.WriteLine(familyName);
			if (font != null) fonts.Add(font);
			fonts.Add(_fonts.DefaultFont);
			return fonts;
		}
	}
}
